#!/usr/bin/env python3
# -*- coding: utf-8 -*-
#
# 2020 Nico Schottelius (nico.schottelius at ungleich.ch)
#
# This file is part of uncloud.
#
# uncloud is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
#
# uncloud is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with uncloud. If not, see <http://www.gnu.org/licenses/>.
#
#

class Config(object):
    def __init__(self, arguments):
        """ read arguments dicts as a base """

        self.arguments = arguments

        # Split them so *etcd_args can be used and we can
        # iterate over etcd_hosts
        self.etcd_hosts = [ arguments['etcd_host'] ]
        self.etcd_args = {
            'ca_cert': arguments['etcd_ca_cert'],
            'cert_cert': arguments['etcd_cert_cert'],
            'cert_key': arguments['etcd_cert_key'],
#            'user': None,
#            'password': None
        }
        self.etcd_prefix = '/nicohack/'
